/* ============================================================ */
/* File:	example.c					*/
/* Author:	Dr. M. Chen, University of Wales Swansea	*/
/* Date:	First created on 31/1/95 & modified on 1/2/95	*/
/* Description:	This simple program demonstrates the usage of	*/
/*		some subroutines defined in shop_subs.c.  	*/
/*		However, Please note it hardly bears any	*/
/*		resemblance to the operating system coursework.	*/
/* ============================================================ */

#include "shop_subs.h"

int main()
{
	/* at time T0 */
	/* 4 customers and 2 waiting chairs. with mutual exclusion. */
	open_barbershop(4, 2, MUTUAL_EXCLUSION_OFF);

	/* cannot draw anything until open_barbershop() is called */
	draw_message("At time T0: open the barbershop");
	barber_enters_barbershop();
	barber_goes_to_sleep();

	/* at time T1 */
	draw_message("At time T1: customers 0, 1, 2 arrive. 2 leaves late.");
	customer_enters_barbershop(0);
	customer_enters_barbershop(1);
	customer_enters_barbershop(2);

	customer_gets_waiting_chair(0);
	customer_gets_waiting_chair(1);
	customer_leaves_barbershop(2);

	/* at time T2 */
	draw_message("At time T2: customer 0 is having a haircut. ");
	customer_gets_barber_chair(0);
	barber_becomes_busy();
	customer_has_haircut(0);
	barber_goes_to_sleep();

	/* at time T3 */
	draw_message("At time T3: customer 3 arrives, 1 has a haircut.");
	customer_enters_barbershop(3);
	customer_leaves_barbershop(0);
	customer_gets_barber_chair(1);
	customer_gets_waiting_chair(3);
	barber_becomes_busy();
	customer_has_haircut(1);
	
	/* at time T4 */
	draw_message("At time T4: customer 3 has a haircut.");
	barber_goes_to_sleep();
	customer_leaves_barbershop(1);
	customer_gets_barber_chair(3);
	barber_becomes_busy();
	customer_has_haircut(3);

	/* at time T5 */
	draw_message("At time T5: close the barbershop.");
	customer_leaves_barbershop(3);
	barber_leaves_barbershop();
	close_barbershop();

	return(0);

}
